
#include <stdio.h>
#include "bignum.h"
#include "util.h"
#include "print.h"

int
test_shl()
{
	unsigned short aa[] = {0xFFFF,0x0000};
	unsigned short bb[] = {0x1000,0x0000};
	unsigned short cc[] = {0x321f,0x7654,0xBA98,0xFEDC};
	unsigned short dd[] = {0x0000, 0x4321, 0xADCD, 0x0000, 0x0000, 0x0000,0xCCCC,0x0000,0xBBBB,0x0000,0xAAAA,0x0000,0xffff};
	unsigned short ee[] = {0x1234};
	unsigned short ff[] = {0x7654, 0xBA98, 0xFEDC};
	struct bignum *pa, *pb;
	unsigned int shift;
	pa = bnum_new();
	pb = bnum_new();
	
	bnum_set_safe(pa, ee, 1, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 8;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");

	bnum_set_safe(pa, ee, 1, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 4;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	bnum_set_safe(pa, ff, 3, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 8;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	bnum_set_safe(pa, ff, 3, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 12;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	bnum_set_safe(pa, ff, 3, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 20;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	bnum_set_safe(pa, aa, 2, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 16;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	
	bnum_set_safe(pb, bb, 2, 1);
	printf("         ");
	bnum_printhex(pb);
	shift = 4;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pb, shift);
	bnum_printhex(pb);
	printf("\n\n");
	
	bnum_set_safe(pa, cc, 4, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 12;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	bnum_set_safe(pa, cc, 4, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 48;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	bnum_set_safe(pa, cc, 4, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 20;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	bnum_set_safe(pa, cc, 4, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 52;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	
	bnum_set_safe(pa, dd, 13, 0);
	printf("         ");
	bnum_printhex(pa);
	shift = 52;
	printf("\nafter %d shl: ",shift);
	bnum_shl(pa, shift);
	bnum_printhex(pa);
	printf("\n\n");
	
	
	return 0;
}

int
main(int argc, char **argv)
{
	test_shl();
	return 0;
}
